function [nip] = newtintpol(uzly,ff)
% function [nip] = newtintpol(uzly,ff)
% Newtonuv interpolacni polynom
% uzly,ff - radkove vektory
% nip - Newt. interpol. polynom

uzly=uzly(:);
ff=ff(:);
n=length(uzly)-1; %stupen polynomu
pomdif=zeros(n+1,n+1);
pomdif(:,1)=ff;
nip=ff(1);
pp=1; % pomocny polynom
for k=1:n % k je rad pomerne diference
    ps=pomdif(:,k);
    citatel=ps(2:n+2-k)-ps(1:n+1-k);
    jmenovatel=uzly(k+1:n+1)-uzly(1:n+1-k);
    pomdif(1:n+1-k,k+1)=citatel./jmenovatel;
    pp=conv(pp,[1, -uzly(k)]);
    nip=[0,nip]+pomdif(1,k+1)*pp;
end

end

